#ifndef GPSLOGHANDLER_H
#define GPSLOGHANDLER_H

#include<qpe/qpeapplication.h>
#include<pthread.h>
#include<qdir.h>
#include<qfile.h>
#include<qtextstream.h>
#include<qstring.h>
#include<qstringlist.h>
#include<vector.h>
#include"coordinate.h"

#include<iostream.h>

extern QPEApplication *_app;

class GpsLogHandler {
public:
	GpsLogHandler(int recentTerm = 1, int recentLogNum = 600,
			int obsolateTerm = 10);
	~GpsLogHandler();

	void start(void);
	void run(void);
	void stop(void);
	inline bool isAlive(void) {
		return _alive;
	}
	;
	Coordinate getNowCoordinate();
	double getNowDirection();
	void setLogDir(QString logDir);
	QString getLogDir();
	void setDevFile(QString devFile);
	void setGpsOutput(QString gpsOutput);
	void loadObsolateLogFile(QString logFile);
	bool isStopped();
	void changeDebugPrint();
	void setRecentLogFirst();
	bool endRecentLog();
	Coordinate getNextRecentLog();
	void setObsolateLogFirst();
	bool endObsolateLog();
	Coordinate getNextObsolateLog();

private:
	QString _basePath;
	QString _gpsLogDir;
	QFile _gpsLogFile;
	QFile _gpsDevFile;
	volatile bool _stopped;
	volatile bool _alive;
	bool _debug_print;
	bool _gpsOutputWGS84;
	Coordinate _coordinate;
	double _direction;
	pthread_t _thread_id;
	pthread_mutex_t _mutex_id;
	int _recentTerm;
	int _recentLogNum;
	int _recentNext;
	int _recentPtr;
	bool _recentLogFull;
	Coordinate* _recentLog;
	int _obsolateTerm;
	vector<Coordinate>::iterator _obsolateIt;
	vector<Coordinate> _obsolateLog;
};

void* thread_func(void *pGpsLogHandler);

#endif //GPSLOGHANDLER_H
